#ifndef HELPER_H
#define HELPER_H

#include <kauth.h>
#include <QObject>
#include <QtDBus/QDBusInterface>
#include <QtAccountsService/AccountsManager>
#include <QtAccountsService/UserAccount>
#include <QProcess>
#include <QFile>
using namespace KAuth;
using namespace QtAccountsService;

/* The functions here run as ROOT.  So be careful. */
class chattr
{
public:
  chattr()
  {
     if(QFile::exists("/usr/bin/nde-chattr"))
     {
        QDBusInterface* interface = new QDBusInterface(QString::fromLatin1("com.nde.chattr"),
                                                             QString::fromLatin1("/ndeChattr"),
                                                             QString::fromLatin1("com.nde.chattr"),
                                                             QDBusConnection::systemBus());
        interface->call("cannelChattr");
        delete interface;
      }
  }
  ~chattr()
  {
    if(QFile::exists("/usr/bin/nde-chattr"))
    {
        QDBusInterface* interface = new QDBusInterface(QString::fromLatin1("com.nde.chattr"),
                                                             QString::fromLatin1("/ndeChattr"),
                                                             QString::fromLatin1("com.nde.chattr"),
                                                             QDBusConnection::systemBus());
        interface->call("addChattr");
        delete interface;
    }
  }
};

class AuthHelper : public QObject {
    Q_OBJECT
public:
    AuthHelper();

public Q_SLOTS:
    ActionReply changecpuscheduler(const QVariantMap &parameters);

    ActionReply setntp(const QVariantMap &parameters);
    ActionReply settimezone(const QVariantMap &parameters);
    ActionReply setdatetime(const QVariantMap &parameters);
    ActionReply setdesktopfile(const QVariantMap &parameters);
    ActionReply createuser(const QVariantMap &parameters);
    ActionReply setusername(const QVariantMap &parameters);
    ActionReply setpassword(const QVariantMap &parameters);
    ActionReply setaccounttype(const QVariantMap &parameters);
    ActionReply deleteuser(const QVariantMap &parameters);
    ActionReply setautologin(const QVariantMap &parameters);
    ActionReply setavatar(const QVariantMap &parameters);
    ActionReply getlog(const QVariantMap &parameters);
    ActionReply getfiles(const QVariantMap &args);
    ActionReply rmfiles(const QVariantMap &parameters);
    ActionReply compresslogs(const QVariantMap &parameters);
    ActionReply pictureschanged(const QVariantMap &parameters);
    ActionReply changehostname(const QVariantMap &parameters);
    //修改系统设置的值
    ActionReply changesettingvalue(const QVariantMap &parameters);
    ActionReply changeavatarname(const QVariantMap &parameters);
    ActionReply installfont(const QVariantMap &parameters);
    ActionReply setscaling(const QVariantMap &parameters);
private:
    void AvatarNRename(QString oldName, QString newName);
    QString WallpaperRename(QString oldName);

private:
    QDBusInterface *mDateTimeInterface;
};


#endif // HELPER_H
